
Graphics3D(800, 600, 0, 2)

; 
Local RoomMesh% = LoadMesh("room.b3d")
Local RoomLight% = CreateLight(2)
PositionEntity(RoomLight, 0.0, 5.0, 0.0)

;   
; :  + -
Local PatternTexture% = LoadTexture("pattern.png", 1 + 2)

;    
; :  +         
;  -
Local OutletTexture% = CreateTexture(256, 512, 1 + 256)
;  -
Local InletTexture% = CreateTexture(256, 512, 1 + 256)

;  
Local PortalsMesh% = CreateMesh()
;    +   -
EntityFX(PortalsMesh, 1 + 32)

;  -
Local OutletBrush% = CreateBrush(254, 174, 104)
;     
BrushTexture(OutletBrush, OutletTexture, 0, 0)
BrushTexture(OutletBrush, PatternTexture, 0, 1)
;  -
Local OutletSurface% = CreateSurface(PortalsMesh, OutletBrush)
;  - ( )
AddVertex(OutletSurface, 3.5 - 1.25, 2.5 + 2.5, 5.0 - 0.01, 0.0, 0.0)
AddVertex(OutletSurface, 3.5 + 1.25, 2.5 + 2.5, 5.0 - 0.01, 1.0, 0.0)
AddVertex(OutletSurface, 3.5 + 1.25, 2.5 - 2.5, 5.0 - 0.01, 1.0, 1.0)
AddVertex(OutletSurface, 3.5 - 1.25, 2.5 - 2.5, 5.0 - 0.01, 0.0, 1.0)
AddTriangle(OutletSurface, 0, 1, 2)
AddTriangle(OutletSurface, 2, 3, 0)

;  -
Local InletBrush% = CreateBrush(103, 172, 255)
;     
BrushTexture(InletBrush, InletTexture, 0, 0)
BrushTexture(InletBrush, PatternTexture, 0, 1)
;  -
Local InletSurface% = CreateSurface(PortalsMesh, InletBrush)
;  - ( )
AddVertex(InletSurface, 5.0 - 0.01, 2.5 + 2.5, 3.5 + 1.25, 0.0, 0.0)
AddVertex(InletSurface, 5.0 - 0.01, 2.5 + 2.5, 3.5 - 1.25, 1.0, 0.0)
AddVertex(InletSurface, 5.0 - 0.01, 2.5 - 2.5, 3.5 - 1.25, 1.0, 1.0)
AddVertex(InletSurface, 5.0 - 0.01, 2.5 - 2.5, 3.5 + 1.25, 0.0, 1.0)
AddTriangle(InletSurface, 0, 1, 2)
AddTriangle(InletSurface, 2, 3, 0)

;  -
Local OutletCamera% = CreateCamera()
;  
CameraProjMode(OutletCamera, 0)
;    
CameraRange(OutletCamera, 0.01, 100.0)
;    
PositionEntity(OutletCamera, 3.5, 2.5, 9.0)
;  ,  
RotateEntity(OutletCamera, 0.0, 180.0, 0.0)

;  -
Local InletCamera% = CreateCamera()
;  
CameraProjMode(InletCamera, 0)
;    
CameraRange(InletCamera, 0.01, 100.0)
;    
PositionEntity(InletCamera, 9.0, 2.5, 3.5)
;  ,  
RotateEntity(InletCamera, 0.0, 90.0, 0.0)

;  
Local MainPosX# = 1.5, MainPosY# = 2.5, MainPosZ# = 1.5
Local MainRotX# = 0.0, MainRotY# = -45.0
Local MainCamera% = CreateCamera()
CameraRange(MainCamera, 0.01, 100.0)
PositionEntity(MainCamera, MainPosX, MainPosY, MainPosZ)
RotateEntity(MainCamera, MainRotX, MainRotY, 0.0)
;    
Local MainSphere% = CreateSphere()
EntityColor(MainSphere, 0, 0, 0)
ScaleEntity(MainSphere, 0.1, 0.1, 0.1)
PositionEntity(MainSphere, MainPosX, MainPosY, MainPosZ)

Repeat

	;   
	Local MouseSpeedX% = MouseXSpeed()
	Local MouseSpeedY% = MouseYSpeed()
	MoveMouse(800 / 2, 600 / 2)
	MainRotX = MainRotX + MouseSpeedY * 0.2
	If MainRotX < -85 Then MainRotX = -85
	If MainRotX >  85 Then MainRotX =  85
	MainRotY = MainRotY - MouseSpeedX * 0.2
	RotateEntity(MainCamera, MainRotX, MainRotY, 0)
	Local MainDirX# = GetMatElement(MainCamera, 2, 0)
	Local MainDirY# = GetMatElement(MainCamera, 2, 1)
	Local MainDirZ# = GetMatElement(MainCamera, 2, 2)
	Local MainMovX# = 0.0
	Local MainMovY# = 0.0
	Local MainMovZ# = 0.0
	If KeyDown(17) Then
		MainMovX = MainMovX + MainDirX
		MainMovY = MainMovY + MainDirY
		MainMovZ = MainMovZ + MainDirZ
	End If
	If KeyDown(31) Then
		MainMovX = MainMovX - MainDirX
		MainMovY = MainMovY - MainDirY
		MainMovZ = MainMovZ - MainDirZ
	End If
	If KeyDown(32) Then
		MainMovX = MainMovX + MainDirZ
		MainMovZ = MainMovZ - MainDirX
	End If
	If KeyDown(30) Then
		MainMovX = MainMovX - MainDirZ
		MainMovZ = MainMovZ + MainDirX
	End If
	Local MainSpeed# = MainMovX * MainMovX + MainMovY * MainMovY + MainMovZ * MainMovZ
	If MainSpeed > 0.001 Then
		MainSpeed = 0.065 / Sqr(MainSpeed)
		MainPosX = MainPosX + MainMovX * MainSpeed
		MainPosY = MainPosY + MainMovY * MainSpeed
		MainPosZ = MainPosZ + MainMovZ * MainSpeed
		PositionEntity(MainCamera, MainPosX, MainPosY, MainPosZ)
		PositionEntity(MainSphere, MainPosX, MainPosY, MainPosZ)
	End If
	
	;   
	CameraProjMode(MainCamera, 0)
	
	;   -
	CameraProjMode(OutletCamera, 1)
	;    
	RenderWorld()
	;   -
	CameraProjMode(OutletCamera, 0)
	;        -
	CopyRect(800 / 2 - 256 / 2, 600 / 2 - 512 / 2, 256, 512, 0, 0, FrontBuffer(), TextureBuffer(InletTexture))
	
	;   -
	CameraProjMode(InletCamera, 1)
	;    
	RenderWorld()
	;   -
	CameraProjMode(InletCamera, 0)
	;        -
	CopyRect(800 / 2 - 256 / 2, 600 / 2 - 512 / 2, 256, 512, 0, 0, FrontBuffer(), TextureBuffer(OutletTexture))
	
	;   
	CameraProjMode(MainCamera, 1)
	
	;  
	RenderWorld()
	
	Flip()
	
Until KeyDown(1)

End
